image: python:3.6.6

stages:
- test
- deploy

unittest:
  stage: test
  tags:
  - docker
  script:
  - pip install -r build-requirements.txt
  - pip install -r requirements.txt
  - flake8
  - pytest --cov=pyconf
  - coverage html
  - pyroma -d .
  artifacts:
    paths:
    - htmlcov
    expire_in: 8 weeks

sphinx:
  stage: test
  tags:
  - docker
  script:
  - pip install -r build-requirements.txt
  - python setup.py build_sphinx
  artifacts:
    paths:
    - build/sphinx
    expire_in: 8 weeks

# Publish the tagged version to PyPi (when tagged).
# We expect the following environment variables: -
#   TWINE_USERNAME
#   TWINE_PASSWORD
deploy:
  stage: deploy
  tags:
  - docker
  script:
  - pip install -r package-requirements.txt
  - pip install -r requirements.txt
  - python setup.py bdist_wheel
  - twine upload dist/*
  dependencies:
  - unittest
  only:
  - tags
